﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Infragistics.WebUI.UltraWebNavigator;

namespace IssueExample
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadTree();
            }
        }

        #region Load Tree With Dummy Data

        private void LoadTree()
        {
            Node root = new Node();
            root.Text = "Root";

            AddSubNodes(root, 2);

            foreach (Node n in root.Nodes)
                AddSubNodes(n, 4);

            UltraWebTree1.Nodes.Add(root);
            UltraWebTree1.Nodes[0].Expand(true);
        }

        private void AddSubNodes(Node n, int count)
        {
            for (int i = 1; i <= count; i++)
            {
                n.Nodes.Add(string.Format("Level {0} - {1}", n.Level + 1, i));
            }
        }

        #endregion

        protected void UltraWebTree1_NodeClicked(object sender, WebTreeNodeEventArgs e)
        {
            LoadItems(e.Node.Level, e.Node.Index);
        }

        private void LoadItems(int level, int index)
        {
            ListBox1.Items.Clear();
            ListBox2.Items.Clear();

            int length = 4;

            for (int i = 0; i < length; i++)
            {
                ListBox1.Items.Add(
                    new ListItem()
                    {
                        Text = string.Format("Selected Item L{0} I{1} - {2}",level,index, i),
                        Value = i.ToString()
                    });
            }

            for (int i = 0; i < length; i++)
            {
                ListBox2.Items.Add(
                    new ListItem()
                    {
                        Text = string.Format("Available Item L{0} I{1} - {2}", level, index, i),
                        Value = i.ToString()
                    });
            }
        }

        protected void btnAdd_Click(object sender, EventArgs e)
        {
            MoveSelected(ListBox2, ListBox1, false);
        }

        protected void btnRemove_Click(object sender, EventArgs e)
        {
            MoveSelected(ListBox1, ListBox2, false);
        }

        private void MoveSelected(ListBox source, ListBox target, bool allItems)
        {
            if (allItems)
            {
                foreach (ListItem item in source.Items)
                {
                    target.Items.Add(item);
                }
                source.Items.Clear();
            }
            else
                for (int i = source.Items.Count - 1; i >= 0; i--)
                {
                    ListItem item = source.Items[i];

                    if (item.Selected)
                    {
                        target.Items.Add(item);
                        source.Items.RemoveAt(i);
                    }
                }
        }
    }
}
